Update target section.
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992-99, 2000, 2001 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="intl mmalloc libiberty opcodes bfd readline gash db tcl tk tcl8.1 tk8.1 tclX itcl tix libgui"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # Set up configure/Makefile variables if libstdc++-v3 is to be built.
51 if [ "${enable_libstdcxx_v3}" = "yes" ] && test -d $srcdir/libstdc++-v3; then
52 libstdcxx_version="target-libstdc++-v3"
53 # Don't use libstdc++-v3's flags to configure/build itself.
54 libstdcxx_flags='`case $$dir in libstdc++-v3) ;; *) cat $$r/$(TARGET_SUBDIR)/libstdc++-v3/src/libstdc++.INC 2>/dev/null || : ;; esac` -L$$r/$(TARGET_SUBDIR)/libstd++-v3/src -L$$r/$(TARGET_SUBDIR)/libstd++-v3/src/.libs'
55 else
56 libstdcxx_version="target-libio target-libstdc++"
57 libstdcxx_flags='-isystem $$s/libstdc++ -isystem $$s/libstdc++/std -isystem $$s/libstdc++/stl -isystem $$s/libio/ -isystem $$s/libio/stdio -L$$r/$(TARGET_SUBDIR)/libstdc++'
58 fi
59
60 # these tools are built for the host environment
61 # Note, the powerpc-eabi build depends on sim occurring before gdb in order to
62 # know that we are building the simulator.
63 host_tools="texinfo byacc flex bison binutils ld gas gcc cgen sid sim gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu ash bash bzip2 m4 autoconf automake libtool ispell grep diff rcs cvssrc fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils snavigator libtool gettext zip"
64
65 # these libraries are built for the target environment, and are built after
66 # the host libraries and the host tools (which may be a cross compiler)
67 #
68 target_libs="target-libiberty \
69 target-libgloss \
70 target-newlib \
71 ${libstdcxx_version} \
72 target-libf2c \
73 target-libchill \
74 target-libffi \
75 target-libjava \
76 target-zlib \
77 target-boehm-gc \
78 target-qthreads \
79 target-libobjc"
80
81 # these tools are built using the target libs, and are intended to run only
82 # in the target environment
83 #
84 # note: any program that *uses* libraries that are in the "target_libs"
85 # list belongs in this list. those programs are also very likely
86 # candidates for the "native_only" list which follows
87 #
88 target_tools="target-examples target-groff target-gperf"
89
90 ################################################################################
91
92 ## These two lists are of directories that are to be removed from the
93 ## ${configdirs} list for either cross-compilations or for native-
94 ## compilations. For example, it doesn't make that much sense to
95 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
96 ## a native environment.
97
98 # directories to be built in the native environment only
99 #
100 # This must be a single line because of the way it is searched by grep in
101 # the code below.
102 native_only="autoconf automake libtool cvssrc emacs emacs19 fileutils find gawk gettext grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time ash bash bzip2 prms snavigator gnuserv target-gperf"
103
104 # directories to be built in a cross environment only
105 #
106 cross_only="target-libgloss target-newlib target-cygmon target-opcodes target-libstub"
107
108 ## All tools belong in one of the four categories, and are assigned above
109 ## We assign ${configdirs} this way to remove all embedded newlines. This
110 ## is important because configure will choke if they ever get through.
111 ## ${configdirs} is directories we build using the host tools.
112 ## ${target_configdirs} is directories we build using the target tools.
113 #
114 configdirs=`echo ${host_libs} ${host_tools}`
115 target_configdirs=`echo ${target_libs} ${target_tools}`
116
117 ################################################################################
118
119 srctrigger=move-if-change
120 srcname="gnu development package"
121
122 # This gets set non-empty for some net releases of packages.
123 appdirs=""
124
125 # per-host:
126
127 # Work in distributions that contain no compiler tools, like Autoconf.
128 if [ -d ${srcdir}/config ]; then
129 case "${host}" in
130 m68k-hp-hpux*)
131 host_makefile_frag="${host_makefile_frag} config/mh-hp300"
132 ;;
133 m68k-apollo-sysv*)
134 host_makefile_frag="${host_makefile_frag} config/mh-apollo68"
135 ;;
136 m68k-apollo-bsd*)
137 host_makefile_frag="${host_makefile_frag} config/mh-a68bsd"
138 ;;
139 m88k-dg-dgux*)
140 host_makefile_frag="${host_makefile_frag} config/mh-dgux"
141 ;;
142 m88k-harris-cxux*)
143 host_makefile_frag="${host_makefile_frag} config/mh-cxux"
144 ;;
145 m88k-motorola-sysv*)
146 host_makefile_frag="${host_makefile_frag} config/mh-delta88"
147 ;;
148 mips*-dec-ultrix*)
149 host_makefile_frag="${host_makefile_frag} config/mh-decstation"
150 ;;
151 mips*-nec-sysv4*)
152 host_makefile_frag="${host_makefile_frag} config/mh-necv4"
153 ;;
154 mips*-sgi-irix6*)
155 host_makefile_frag="${host_makefile_frag} config/mh-irix6"
156 ;;
157 mips*-sgi-irix5*)
158 host_makefile_frag="${host_makefile_frag} config/mh-irix5"
159 ;;
160 mips*-sgi-irix4*)
161 host_makefile_frag="${host_makefile_frag} config/mh-irix4"
162 ;;
163 mips*-sgi-irix3*)
164 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
165 ;;
166 mips*-*-sysv4*)
167 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
168 ;;
169 mips*-*-sysv*)
170 host_makefile_frag="${host_makefile_frag} config/mh-riscos"
171 ;;
172 i370-ibm-opened*)
173 host_makefile_frag="${host_makefile_frag} config/mh-openedition"
174 ;;
175 i[3456]86-*-sysv5*)
176 host_makefile_frag="${host_makefile_frag} config/mh-sysv5"
177 ;;
178 i[3456]86-*-dgux*)
179 host_makefile_frag="${host_makefile_frag} config/mh-dgux386"
180 ;;
181 i[3456]86-ncr-sysv4.3*)
182 host_makefile_frag="${host_makefile_frag} config/mh-ncrsvr43"
183 ;;
184 i[3456]86-ncr-sysv4*)
185 host_makefile_frag="${host_makefile_frag} config/mh-ncr3000"
186 ;;
187 i[3456]86-*-sco3.2v5*)
188 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
189 ;;
190 i[3456]86-*-sco*)
191 host_makefile_frag="${host_makefile_frag} config/mh-sco"
192 ;;
193 i[3456]86-*-udk*)
194 host_makefile_frag="${host_makefile_frag} config/mh-sysv5"
195 ;;
196 i[3456]86-*-isc*)
197 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
198 ;;
199 i[3456]86-*-solaris2*)
200 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
201 ;;
202 i[3456]86-*-aix*)
203 host_makefile_frag="${host_makefile_frag} config/mh-aix386"
204 ;;
205 i[3456]86-*-msdosdjgpp*)
206 host_makefile_frag="${host_makefile_frag} config/mh-djgpp"
207 ;;
208 *-cygwin*)
209 host_makefile_frag="${host_makefile_frag} config/mh-cygwin"
210 ;;
211 *-mingw32*)
212 host_makefile_frag="${host_makefile_frag} config/mh-mingw32"
213 ;;
214 *-interix*)
215 host_makefile_frag="${host_makefile_frag} config/mh-interix"
216 ;;
217 *-windows*)
218 host_makefile_frag="${host_makefile_frag} config/mh-windows"
219 ;;
220 vax-*-ultrix2*)
221 host_makefile_frag="${host_makefile_frag} config/mh-vaxult2"
222 ;;
223 *-*-solaris2*)
224 host_makefile_frag="${host_makefile_frag} config/mh-solaris"
225 ;;
226 m68k-sun-sunos*)
227 host_makefile_frag="${host_makefile_frag} config/mh-sun3"
228 ;;
229 *-hp-hpux[78]*)
230 host_makefile_frag="${host_makefile_frag} config/mh-hpux8"
231 ;;
232 *-hp-hpux*)
233 host_makefile_frag="${host_makefile_frag} config/mh-hpux"
234 ;;
235 *-*-hiux*)
236 host_makefile_frag="${host_makefile_frag} config/mh-hpux"
237 ;;
238 rs6000-*-lynxos*)
239 host_makefile_frag="${host_makefile_frag} config/mh-lynxrs6k"
240 ;;
241 *-*-lynxos*)
242 host_makefile_frag="${host_makefile_frag} config/mh-lynxos"
243 ;;
244 *-*-sysv4*)
245 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
246 ;;
247 *-*-sysv*)
248 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
249 ;;
250 esac
251 fi
252
253 # If we aren't going to be using gcc, see if we can extract a definition
254 # of CC from the fragment.
255 if [ -z "${CC}" ] && [ "${build}" = "${host}" ]; then
256 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
257 found=
258 for dir in $PATH; do
259 test -z "$dir" && dir=.
260 if test -f $dir/gcc; then
261 found=yes
262 break
263 fi
264 done
265 IFS="$save_ifs"
266 if [ -z "${found}" ] && [ -n "${host_makefile_frag}" ] && [ -f "${srcdir}/${host_makefile_frag}" ]; then
267 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
268 if [ -n "${xx}" ] ; then
269 CC=$xx
270 fi
271 fi
272 fi
273
274 # We default to --with-shared on platforms where -fpic is meaningless.
275 # Well, we don't yet, but we will.
276 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
277 case "${target}" in
278 alpha*-dec-osf*) enable_shared=yes ;;
279 alpha*-*-linux*) enable_shared=yes ;;
280 mips-sgi-irix5*) enable_shared=yes ;;
281 *) enable_shared=no ;;
282 esac
283 fi
284
285 case "${enable_shared}" in
286 yes) shared=yes ;;
287 no) shared=no ;;
288 "") shared=no ;;
289 *) shared=yes ;;
290 esac
291
292 if [ x${shared} = xyes ]; then
293 case "${host}" in
294 alpha*-*-linux*)
295 host_makefile_frag="${host_makefile_frag} config/mh-elfalphapic"
296 ;;
297 arm*-*-*)
298 host_makefile_frag="${host_makefile_frag} config/mh-armpic"
299 ;;
300 hppa*-*-*)
301 host_makefile_frag="${host_makefile_frag} config/mh-papic"
302 ;;
303 i[3456]86-*-cygwin*)
304 # We don't want -fPIC on Cygwin.
305 ;;
306 i[3456]86-*-*)
307 host_makefile_frag="${host_makefile_frag} config/mh-x86pic"
308 ;;
309 i370-*-*)
310 host_makefile_frag="${host_makefile_frag} config/mh-i370pic"
311 ;;
312 ia64-*-*)
313 host_makefile_frag="${host_makefile_frag} config/mh-ia64pic"
314 ;;
315 sparc64-*-*)
316 host_makefile_frag="${host_makefile_frag} config/mh-sparcpic"
317 ;;
318 powerpc*-*-aix*)
319 # We don't want -fPIC on AIX.
320 ;;
321 powerpc*-*-*)
322 host_makefile_frag="${host_makefile_frag} config/mh-ppcpic"
323 ;;
324 s390-* | s390x-*)
325 host_makefile_frag="${host_makefile_frag} config/mh-s390pic"
326 ;;
327 *-*-*)
328 if test -f ${srcdir}/config/mh-${host_cpu}pic; then
329 host_makefile_frag="${host_makefile_frag} config/mh-${host_cpu}pic"
330 fi
331 ;;
332 esac
333 fi
334
335 rm -f mh-frag
336 if [ -n "${host_makefile_frag}" ] ; then
337 for f in ${host_makefile_frag}
338 do
339 cat ${srcdir}/$f >> mh-frag
340 done
341 host_makefile_frag=mh-frag
342 fi
343
344 # per-target:
345
346 case "${target}" in
347 v810*)
348 target_makefile_frag="${target_makefile_frag} config/mt-v810"
349 ;;
350 i[3456]86-*-netware*)
351 target_makefile_frag="${target_makefile_frag} config/mt-netware"
352 ;;
353 powerpc-*-netware*)
354 target_makefile_frag="${target_makefile_frag} config/mt-netware"
355 ;;
356 *-*-linux-gnu*)
357 target_makefile_frag="${target_makefile_frag} config/mt-linux"
358 ;;
359 *-*-aix4.[3456789]* | *-*-aix[56789].*)
360 target_makefile_frag="${target_makefile_frag} config/mt-aix43"
361 ;;
362 mips*-*-pe | sh*-*-pe | *arm-wince-pe)
363 target_makefile_frag="${target_makefile_frag} config/mt-wince"
364 ;;
365 esac
366
367 # If --enable-target-optspace always use -Os instead of -O2 to build
368 # the target libraries, similarly if it is not specified, use -Os
369 # on selected platforms.
370 case "${enable_target_optspace}:${target}" in
371 yes:*)
372 target_makefile_frag="${target_makefile_frag} config/mt-ospace"
373 ;;
374 :d30v-*)
375 target_makefile_frag="${target_makefile_frag} config/mt-d30v"
376 ;;
377 :m32r-* | :d10v-* | :fr30-*)
378 target_makefile_frag="${target_makefile_frag} config/mt-ospace"
379 ;;
380 no:* | :*)
381 ;;
382 *)
383 echo "*** bad value \"${enable_target_optspace}\" for --enable-target-optspace flag; ignored" 1>&2
384 ;;
385 esac
386
387 skipdirs=
388 gasdir=gas
389 use_gnu_ld=
390 use_gnu_as=
391
392 # some tools are so dependent upon X11 that if we're not building with X,
393 # it's not even worth trying to configure, much less build, that tool.
394
395 case ${with_x} in
396 yes | "") # the default value for this tree is that X11 is available
397 ;;
398 no)
399 skipdirs="${skipdirs} tk libgui gash"
400 ;;
401 *)
402 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
403 ;;
404 esac
405
406 # Some tools are only suitable for building in a "native" situation.
407 # Those are added when we have a host==target configuration. For cross
408 # toolchains, we add some directories that should only be useful in a
409 # cross-compiler.
410
411 is_cross_compiler=
412
413 if [ x"${host}" = x"${target}" ] ; then
414 # when doing a native toolchain, don't build the targets
415 # that are in the 'cross only' list
416 skipdirs="${skipdirs} ${cross_only}"
417 is_cross_compiler=no
418 else
419 # similarly, don't build the targets in the 'native only'
420 # list when building a cross compiler
421 skipdirs="${skipdirs} ${native_only}"
422 is_cross_compiler=yes
423 fi
424
425 # We always want to use the same name for this directory, so that dejagnu
426 # can reliably find it.
427 target_subdir=${target_alias}
428
429 if [ ! -d ${target_subdir} ] ; then
430 if mkdir ${target_subdir} ; then true
431 else
432 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
433 exit 1
434 fi
435 fi
436
437 build_subdir=${build_alias}
438
439 if [ x"${build_alias}" != x"${host}" ] ; then
440 if [ ! -d ${build_subdir} ] ; then
441 if mkdir ${build_subdir} ; then true
442 else
443 echo "'*** could not make ${PWD=`pwd`}/${build_subdir}" 1>&2
444 exit 1
445 fi
446 fi
447 fi
448
449 copy_dirs=
450
451 # Handle --with-headers=XXX. The contents of the named directory are
452 # copied to $(tooldir)/sys-include.
453 if [ x"${with_headers}" != x ]; then
454 if [ x${is_cross_compiler} = xno ]; then
455 echo 1>&2 '***' --with-headers is only supported when cross compiling
456 exit 1
457 fi
458 case "${exec_prefixoption}" in
459 "") x=${prefix} ;;
460 *) x=${exec_prefix} ;;
461 esac
462 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
463 fi
464
465 # Handle --with-libs=XXX. Multiple directories are permitted. The
466 # contents are copied to $(tooldir)/lib.
467 if [ x"${with_libs}" != x ]; then
468 if [ x${is_cross_compiler} = xno ]; then
469 echo 1>&2 '***' --with-libs is only supported when cross compiling
470 exit 1
471 fi
472 # Copy the libraries in reverse order, so that files in the first named
473 # library override files in subsequent libraries.
474 case "${exec_prefixoption}" in
475 "") x=${prefix} ;;
476 *) x=${exec_prefix} ;;
477 esac
478 for l in ${with_libs}; do
479 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
480 done
481 fi
482
483 # If both --with-headers and --with-libs are specified, default to
484 # --without-newlib.
485 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
486 if [ x"${with_newlib}" = x ]; then
487 with_newlib=no
488 fi
489 fi
490
491 # Recognize --with-newlib/--without-newlib.
492 if [ x${with_newlib} = xno ]; then
493 skipdirs="${skipdirs} target-newlib"
494 elif [ x${with_newlib} = xyes ]; then
495 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
496 fi
497
498 # Default to using --with-stabs for certain targets.
499 if [ x${with_stabs} = x ]; then
500 case "${target}" in
501 mips*-*-irix6*)
502 ;;
503 mips*-*-* | alpha*-*-osf*)
504 with_stabs=yes;
505 withoptions="${withoptions} --with-stabs"
506 ;;
507 esac
508 fi
509
510 # Handle ${copy_dirs}
511 set fnord ${copy_dirs}
512 shift
513 while [ $# != 0 ]; do
514 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
515 :
516 else
517 echo Copying $1 to $2
518
519 # Use the install script to create the directory and all required
520 # parent directories.
521 if [ -d $2 ]; then
522 :
523 else
524 echo >config.temp
525 ${srcdir}/install-sh -c -m 644 config.temp $2/COPIED
526 fi
527
528 # Copy the directory, assuming we have tar.
529 # FIXME: Should we use B in the second tar? Not all systems support it.
530 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
531
532 # It is the responsibility of the user to correctly adjust all
533 # symlinks. If somebody can figure out how to handle them correctly
534 # here, feel free to add the code.
535
536 echo $1 > $2/COPIED
537 fi
538 shift; shift
539 done
540
541 # Configure extra directories which are host specific
542
543 case "${host}" in
544 i[3456]86-*-go32*)
545 configdirs="$configdirs dosrel" ;;
546 i[3456]86-*-mingw32*)
547 configdirs="$configdirs dosrel" ;;
548 *-cygwin*)
549 configdirs="$configdirs libtermcap dosrel" ;;
550 esac
551
552 # Remove more programs from consideration, based on the host or
553 # target this usually means that a port of the program doesn't
554 # exist yet.
555
556 noconfigdirs=""
557
558 case "${host}" in
559 i[3456]86-*-vsta)
560 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv gettext"
561 ;;
562 i[3456]86-*-go32* | i[3456]86-*-msdosdjgpp*)
563 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv gettext libffi"
564 ;;
565 i[3456]86-*-mingw32*)
566 # noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv"
567 noconfigdirs="expect dejagnu cvs autoconf automake send-pr rcs guile perl texinfo apache inet libtool"
568 ;;
569 i[3456]86-*-beos*)
570 noconfigdirs="$noconfigdirs tk itcl tix libgui gdb"
571 ;;
572 *-*-cygwin*)
573 noconfigdirs="autoconf automake send-pr rcs guile perl apache inet"
574 ;;
575 *-*-netbsd*)
576 noconfigdirs="rcs"
577 ;;
578 ppc*-*-pe)
579 noconfigdirs="patch diff make tk tcl expect dejagnu cvssrc autoconf automake texinfo bison send-pr gprof rcs guile perl apache inet itcl tix db snavigator gnuserv"
580 ;;
581 powerpc-*-beos*)
582 noconfigdirs="$noconfigdirs tk itcl tix libgui gdb dejagnu readline"
583 ;;
584 esac
585
586
587 # Save it here so that, even in case of --enable-libgcj, if the Java
588 # front-end isn't enabled, we still get libgcj disabled.
589 libgcj_saved=$libgcj
590 case $enable_libgcj in
591 yes)
592 # If we reset it here, it won't get added to noconfigdirs in the
593 # target-specific build rules, so it will be forcibly enabled
594 # (unless the Java language itself isn't enabled).
595 libgcj=
596 ;;
597 no)
598 # Make sure we get it printed in the list of not supported target libs.
599 noconfigdirs="$noconfigdirs ${libgcj}"
600 ;;
601 esac
602
603 case "${target}" in
604 *-*-netware)
605 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-newlib target-libiberty target-libgloss target-libffi"
606 ;;
607 *-*-rtems*)
608 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
609 ;;
610 *-*-vxworks*)
611 noconfigdirs="$noconfigdirs target-newlib target-libgloss target-libffi"
612 ;;
613 alpha*-dec-osf*)
614 # ld works, but does not support shared libraries. emacs doesn't
615 # work. newlib is not 64 bit ready. I'm not sure about fileutils.
616 # gas doesn't generate exception information.
617 noconfigdirs="$noconfigdirs gas ld emacs fileutils target-newlib target-libgloss"
618 ;;
619 alpha*-*-*vms*)
620 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss target-libffi"
621 ;;
622 alpha*-*-*)
623 # newlib is not 64 bit ready
624 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
625 ;;
626 sh*-*-pe|mips*-*-pe|*arm-wince-pe)
627 noconfigdirs="$noconfigdirs target-libjava target-libffi target-zlib"
628 noconfigdirs="$noconfigdirs target-boehm-gc target-qthreads target-examples"
629 noconfigdirs="$noconfigdirs target-libiberty texinfo send-pr"
630 noconfigdirs="$noconfigdirs tcl tix tk itcl libgui sim"
631 noconfigdirs="$noconfigdirs expect dejagnu"
632 # the C++ libraries don't build on top of CE's C libraries
633 noconfigdirs="$noconfigdirs ${libstdcxx_version}"
634 skipdirs="$skipdirs target-newlib"
635 case "${host}" in
636 *-*-cygwin*) ;; # keep gdb and readline
637 *) noconfigdirs="$noconfigdirs gdb readline ${libstdcxx_version}"
638 ;;
639 esac
640 ;;
641 arc-*-*)
642 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
643 ;;
644 arm-*-pe*)
645 noconfigdirs="$noconfigdirs target-libgloss"
646 ;;
647 arm-*-oabi*)
648 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
649 ;;
650 thumb-*-coff)
651 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
652 ;;
653 thumb-*-elf)
654 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
655 ;;
656 thumb-*-oabi)
657 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
658 ;;
659 strongarm-*-elf)
660 noconfigdirs="$noconfigdirs target-libffi"
661 ;;
662 strongarm-*-coff)
663 noconfigdirs="$noconfigdirs target-libffi"
664 ;;
665 xscale-*-elf)
666 noconfigdirs="$noconfigdirs target-libffi"
667 ;;
668 xscale-*-coff)
669 noconfigdirs="$noconfigdirs target-libffi"
670 ;;
671 thumb-*-pe)
672 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
673 ;;
674 arm-*-riscix*)
675 noconfigdirs="$noconfigdirs ld target-libgloss target-libffi"
676 ;;
677 c4x-*-*)
678 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-libgloss target-libffi"
679 ;;
680 c54x*-*-* | tic54x-*-*)
681 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-libgloss target-libffi gcc gdb newlib"
682 ;;
683 d10v-*-*)
684 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-libgloss target-libffi"
685 ;;
686 d30v-*-*)
687 ;;
688 fr30-*-elf*)
689 if [ x${is_cross_compiler} != xno ] ; then
690 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
691 fi
692 ;;
693 h8300*-*-*)
694 noconfigdirs="$noconfigdirs target-libgloss"
695 ;;
696 h8500-*-*)
697 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-libgloss target-libffi"
698 ;;
699 hppa*-*-*elf* | \
700 hppa*-*-linux-gnu* | \
701 hppa*-*-lites* | \
702 hppa*64*-*-*)
703 # Do configure ld/binutils/gas for this case.
704 ;;
705 hppa*-*-*)
706 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
707 # cc is gcc, and on any system a user should be able to link cc to
708 # whatever they want. FIXME, emacs emacs19).
709 case "${CC}" in
710 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
711 *) ;;
712 esac
713 # According to Alexandre Oliva <aoliva@redhat.com>, libjava won't
714 # build on HP-UX 10.20.
715 noconfigdirs="$noconfigdirs ld shellutils ${libgcj}"
716 ;;
717 ia64*-*-elf*)
718 # No gdb support yet.
719 noconfigdirs="$noconfigdirs tix readline mmalloc libgui itcl gdb"
720 ;;
721 i[3456]86-*-coff | i[3456]86-*-elf)
722 if [ x${is_cross_compiler} != xno ] ; then
723 target_configdirs="${target_configdirs} target-libstub target-cygmon"
724 fi
725 ;;
726 i[3456]86-*-go32* | i[3456]-*-msdosdjgpp*)
727 # but don't build gdb
728 noconfigdirs="$noconfigdirs gdb ${libstdcxx_version} target-libffi"
729 ;;
730 i[3456]86-*-mingw32*)
731 target_configdirs="$target_configdirs target-mingw"
732 noconfigdirs="$noconfigdirs expect target-libgloss ${libgcj}"
733
734 # Can't build gdb for mingw32 if not native.
735 case "${host}" in
736 i[3456]86-*-mingw32) ;; # keep gdb tcl tk expect etc.
737 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix db snavigator gnuserv"
738 ;;
739 esac
740 ;;
741 *-*-cygwin*)
742 target_configdirs="$target_configdirs target-libtermcap target-winsup"
743 noconfigdirs="$noconfigdirs target-gperf target-libgloss ${libgcj}"
744 # always build newlib.
745 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
746
747 # Can't build gdb for Cygwin if not native.
748 case "${host}" in
749 *-*-cygwin*) ;; # keep gdb tcl tk expect etc.
750 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix libgui db snavigator gnuserv"
751 ;;
752 esac
753 ;;
754 i[3456]86-*-pe)
755 noconfigdirs="$noconfigdirs ${libstdcxx_version} target-libgloss target-libffi"
756 ;;
757 i[3456]86-*-sco3.2v5*)
758 # The linker does not yet know about weak symbols in COFF,
759 # and is not configured to handle mixed ELF and COFF.
760 noconfigdirs="$noconfigdirs ld target-libgloss target-libffi"
761 ;;
762 i[3456]86-*-sco*)
763 noconfigdirs="$noconfigdirs gprof target-libgloss target-libffi"
764 ;;
765 i[3456]86-*-solaris2*)
766 noconfigdirs="$noconfigdirs target-libgloss"
767 ;;
768 i[3456]86-*-sysv4*)
769 # The SYSV4 C compiler doesn't handle Emacs correctly
770 case "${CC}" in
771 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
772 *) ;;
773 esac
774 # but that's okay since emacs doesn't work anyway
775 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss target-libffi"
776 ;;
777 i[3456]86-*-beos*)
778 noconfigdirs="$noconfigdirs gdb target-newlib target-libgloss ${libgcj}"
779 ;;
780 m68hc11-*-*|m6811-*-*|m68hc12-*-*|m6812-*-*)
781 noconfigdirs="$noconfigdirs target-libiberty target-librx target-libg++ target-libstdc++ target-libio target-libf2c target-libchill target-zlib target-libobjc"
782 ;;
783 m68k-*-elf*)
784 if [ x${is_cross_compiler} != xno ] ; then
785 target_configdirs="${target_configdirs} target-bsp target-cygmon"
786 fi
787 ;;
788 m68k-*-coff*)
789 if [ x${is_cross_compiler} != xno ] ; then
790 target_configdirs="${target_configdirs} target-bsp target-cygmon"
791 fi
792 ;;
793 mn10200-*-*)
794 noconfigdirs="$noconfigdirs target-libffi"
795 if [ x${is_cross_compiler} != xno ] ; then
796 target_configdirs="${target_configdirs} target-libstub target-cygmon"
797 fi
798 ;;
799 mn10300-*-*)
800 noconfigdirs="$noconfigdirs target-libffi"
801 if [ x${is_cross_compiler} != xno ] ; then
802 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
803 fi
804 ;;
805 powerpc-*-aix*)
806 # copied from rs6000-*-* entry
807 use_gnu_ld=yes
808 ;;
809 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
810 target_configdirs="$target_configdirs target-winsup"
811 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss itcl tix db snavigator gnuserv target-libffi"
812 # always build newlib.
813 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
814 ;;
815 # This is temporary until we can link against shared libraries
816 powerpcle-*-solaris*)
817 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect itcl tix db snavigator gnuserv target-libffi"
818 ;;
819 powerpc-*-beos*)
820 noconfigdirs="$noconfigdirs gdb target-newlib target-libgloss"
821 ;;
822 powerpc-*-eabi)
823 if [ x${is_cross_compiler} != xno ] ; then
824 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
825 fi
826 ;;
827 rs6000-*-lynxos*)
828 # The CVS server code doesn't work on the RS/6000
829 noconfigdirs="$noconfigdirs target-newlib gprof cvssrc target-libffi"
830 ;;
831 rs6000-*-aix*)
832 noconfigdirs="$noconfigdirs gprof target-libffi"
833 use_gnu_ld=yes
834 ;;
835 rs6000-*-*)
836 noconfigdirs="$noconfigdirs gprof target-libffi"
837 ;;
838 m68k-apollo-*)
839 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss target-libffi"
840 ;;
841 mips*-*-irix5*)
842 # The GNU linker does not support shared libraries.
843 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
844 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
845 ;;
846 mips*-*-irix6*)
847 # The GNU assembler does not support IRIX 6.
848 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
849 # Linking libjava exceeds command-line length limits on at least
850 # IRIX 6.2, but not on IRIX 6.5.
851 # Also, boehm-gc won't build on IRIX 6.5, according to Jeffrey Oldham
852 # <oldham@codesourcery.com>
853 noconfigdirs="$noconfigdirs gas gprof emacs target-libgloss ${libgcj}"
854 ;;
855 mips*-dec-bsd*)
856 noconfigdirs="$noconfigdirs gprof target-libgloss target-libffi"
857 ;;
858 mips*-*-bsd*)
859 noconfigdirs="$noconfigdirs gprof target-libgloss target-libffi"
860 ;;
861 mipstx39-*-*)
862 noconfigdirs="$noconfigdirs gprof target-libffi" # same as generic mips
863 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
864 ;;
865 mips*-*-*)
866 noconfigdirs="$noconfigdirs gprof target-libffi"
867 ;;
868 romp-*-*)
869 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss target-libffi"
870 ;;
871 sh-*-*)
872 case "${host}" in
873 i[3456]86-*-vsta) ;; # don't add gprof back in
874 i[3456]86-*-go32*) ;; # don't add gprof back in
875 i[3456]86-*-msdosdjgpp*) ;; # don't add gprof back in
876 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
877 esac
878 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
879 ;;
880 sparc-*-elf*)
881 if [ x${is_cross_compiler} != xno ] ; then
882 target_configdirs="${target_configdirs} target-libstub target-cygmon"
883 fi
884 ;;
885 sparc64-*-elf*)
886 if [ x${is_cross_compiler} != xno ] ; then
887 target_configdirs="${target_configdirs} target-libstub target-cygmon"
888 fi
889 noconfigdirs="$noconfigdirs target-libffi"
890 ;;
891 sparclite-*-*)
892 if [ x${is_cross_compiler} != xno ] ; then
893 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
894 fi
895 noconfigdirs="$noconfigdirs target-libffi"
896 ;;
897 sparc-*-sunos4*)
898 if [ x${is_cross_compiler} != xno ] ; then
899 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
900 else
901 use_gnu_ld=no
902 fi
903 ;;
904 sparc-*-solaris*)
905 case "${host}" in
906 sparc-*-solaris2.8)
907 # According to Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, libjava
908 # won't build correctly on Solaris 8 if there's a
909 # previously-installed version of GCC in the configured prefix.
910 # This problem does not show up on earlier versions of Solaris.
911 noconfigdirs="$noconfigdirs ${libgcj}"
912 ;;
913 esac
914 ;;
915 v810-*-*)
916 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld ${libstdcxx_version} opcodes target-libgloss target-libffi"
917 ;;
918 v850-*-*)
919 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
920 ;;
921 v850e-*-*)
922 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
923 ;;
924 v850ea-*-*)
925 noconfigdirs="$noconfigdirs target-libgloss target-libffi"
926 ;;
927 vax-*-vms)
928 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss target-libffi"
929 ;;
930 vax-*-*)
931 noconfigdirs="$noconfigdirs target-newlib target-libgloss target-libffi"
932 ;;
933 *-*-lynxos*)
934 noconfigdirs="$noconfigdirs target-newlib target-libgloss target-libffi"
935 ;;
936 *-*-macos* | \
937 *-*-mpw*)
938 # Macs want a resource compiler.
939 configdirs="$configdirs grez"
940 noconfigdirs="$noconfigdirs target-libffi"
941 ;;
942 esac
943
944 # If we aren't building newlib, then don't build libgloss, since libgloss
945 # depends upon some newlib header files.
946 case "${noconfigdirs}" in
947 *target-libgloss*) ;;
948 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
949 esac
950
951 # Make sure we don't let GNU ld be added if we didn't want it.
952 if [ x$with_gnu_ld = xno ]; then
953 use_gnu_ld=no
954 noconfigdirs="$noconfigdirs ld"
955 fi
956
957 # Make sure we don't let GNU as be added if we didn't want it.
958 if [ x$with_gnu_as = xno ]; then
959 use_gnu_as=no
960 noconfigdirs="$noconfigdirs gas"
961 fi
962
963 # Figure out what language subdirectories are present.
964 # Look if the user specified --enable-languages="..."; if not, use
965 # the environment variable $LANGUAGES if defined. $LANGUAGES might
966 # go away some day.
967 # NB: embedded tabs in this IF block -- do not untabify
968 if test x"${enable_languages+set}" != xset; then
969 if test x"${LANGUAGES+set}" = xset; then
970 enable_languages="${LANGUAGES}"
971 echo configure.in: warning: setting LANGUAGES is deprecated, use --enable-languages instead 1>&2
972 else
973 enable_languages=all
974 fi
975 else
976 if test x"${enable_languages}" = x ||
977 test x"${enable_languages}" = xyes;
978 then
979 echo configure.in: --enable-languages needs at least one language argument 1>&2
980 exit 1
981 fi
982 fi
983 enable_languages=`echo "${enable_languages}" | sed -e 's/[ ,][ ,]*/,/g' -e 's/,$//'`
984
985 subdirs=
986 for lang in ${srcdir}/gcc/*/config-lang.in ..
987 do
988 case $lang in
989 ..) ;;
990 # The odd quoting in the next line works around
991 # an apparent bug in bash 1.12 on linux.
992 ${srcdir}/gcc/[*]/config-lang.in) ;;
993 *)
994 lang_alias=`sed -n -e 's,^language=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^language=\([^ ]*\).*$,\1,p' $lang`
995 this_lang_libs=`sed -n -e 's,^target_libs=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^target_libs=\([^ ]*\).*$,\1,p' $lang`
996 build_by_default=`sed -n -e 's,^build_by_default=['"'"'"'"]\(.*\)["'"'"'"'].*$,\1,p' -e 's,^build_by_default=\([^ ]*\).*$,\1,p' $lang`
997 if test "x$lang_alias" = x
998 then
999 echo "$lang doesn't set \$language." 1>&2
1000 exit 1
1001 fi
1002 case ${build_by_default},${enable_languages}, in
1003 *,$lang_alias,*) add_this_lang=yes ;;
1004 no,*) add_this_lang=no ;;
1005 *,all,*) add_this_lang=yes ;;
1006 *) add_this_lang=no ;;
1007 esac
1008 if test x"${add_this_lang}" = xyes; then
1009 eval target_libs='"$target_libs "'\"$this_lang_libs\"
1010 else
1011 eval noconfigdirs='"$noconfigdirs "'\"$this_lang_libs\"
1012 fi
1013 ;;
1014 esac
1015 done
1016
1017
1018 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
1019 # $target_configdirs.
1020 # If we have the source for $noconfigdirs entries, add them to $notsupp.
1021
1022 notsupp=""
1023 for dir in . $skipdirs $noconfigdirs ; do
1024 dirname=`echo $dir | sed -e s/target-//g`
1025 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1026 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
1027 if [ -r $srcdir/$dirname/configure ] \
1028 || [ -r $srcdir/$dirname/configure.in ]; then
1029 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1030 true
1031 else
1032 notsupp="$notsupp $dir"
1033 fi
1034 fi
1035 fi
1036 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1037 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
1038 if [ -r $srcdir/$dirname/configure ] \
1039 || [ -r $srcdir/$dirname/configure.in ]; then
1040 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1041 true
1042 else
1043 notsupp="$notsupp $dir"
1044 fi
1045 fi
1046 fi
1047 done
1048
1049 # Sometimes the tools are distributed with libiberty but with no other
1050 # libraries. In that case, we don't want to build target-libiberty.
1051 if [ -n "${target_configdirs}" ]; then
1052 others=
1053 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
1054 if [ "$i" != "libiberty" ]; then
1055 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
1056 others=yes;
1057 break;
1058 fi
1059 fi
1060 done
1061 if [ -z "${others}" ]; then
1062 target_configdirs=
1063 fi
1064 fi
1065
1066 # Deconfigure all subdirectories, in case we are changing the
1067 # configuration from one where a subdirectory is supported to one where it
1068 # is not.
1069 if [ -z "${norecursion}" ] && [ -n "${configdirs}" ]; then
1070 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
1071 rm -f $i/Makefile
1072 done
1073 fi
1074 if [ -z "${norecursion}" ] && [ -n "${target_configdirs}" ]; then
1075 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
1076 rm -f ${target_subdir}/$i/Makefile
1077 done
1078 fi
1079
1080 # Produce a warning message for the subdirs we can't configure.
1081 # This isn't especially interesting in the Cygnus tree, but in the individual
1082 # FSF releases, it's important to let people know when their machine isn't
1083 # supported by the one or two programs in a package.
1084
1085 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
1086 # If $appdirs is non-empty, at least one of those directories must still
1087 # be configured, or we error out. (E.g., if the gas release supports a
1088 # specified target in some subdirs but not the gas subdir, we shouldn't
1089 # pretend that all is well.)
1090 if [ -n "$appdirs" ]; then
1091 for dir in $appdirs ; do
1092 if [ -r $dir/Makefile.in ]; then
1093 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1094 appdirs=""
1095 break
1096 fi
1097 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
1098 appdirs=""
1099 break
1100 fi
1101 fi
1102 done
1103 if [ -n "$appdirs" ]; then
1104 echo "*** This configuration is not supported by this package." 1>&2
1105 exit 1
1106 fi
1107 fi
1108 # Okay, some application will build, or we don't care to check. Still
1109 # notify of subdirs not getting built.
1110 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
1111 echo " ${notsupp}" 1>&2
1112 echo " (Any other directories should still work fine.)" 1>&2
1113 fi
1114
1115 # Set with_gnu_as and with_gnu_ld as appropriate.
1116 #
1117 # This is done by determining whether or not the appropriate directory
1118 # is available, and by checking whether or not specific configurations
1119 # have requested that this magic not happen.
1120 #
1121 # The command line options always override the explicit settings in
1122 # configure.in, and the settings in configure.in override this magic.
1123 #
1124 # If the default for a toolchain is to use GNU as and ld, and you don't
1125 # want to do that, then you should use the --without-gnu-as and
1126 # --without-gnu-ld options for the configure script.
1127
1128 if [ x${use_gnu_as} = x ] ; then
1129 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
1130 with_gnu_as=yes
1131 withoptions="$withoptions --with-gnu-as"
1132 fi
1133 fi
1134
1135 if [ x${use_gnu_ld} = x ] ; then
1136 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
1137 with_gnu_ld=yes
1138 withoptions="$withoptions --with-gnu-ld"
1139 fi
1140 fi
1141
1142 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
1143 # can detect this case.
1144
1145 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
1146 with_newlib=yes
1147 withoptions="$withoptions --with-newlib"
1148 fi
1149
1150 if [ x${shared} = xyes ]; then
1151 case "${target}" in
1152 hppa*)
1153 target_makefile_frag="${target_makefile_frag} config/mt-papic"
1154 ;;
1155 i[3456]86-*)
1156 target_makefile_frag="${target_makefile_frag} config/mt-x86pic"
1157 ;;
1158 ia64-*)
1159 target_makefile_frag="${target_makefile_frag} config/mt-ia64pic"
1160 ;;
1161 powerpc*-*-aix*)
1162 # We don't want -fPIC on AIX.
1163 ;;
1164 powerpc*-*)
1165 target_makefile_frag="${target_makefile_frag} config/mt-ppcpic"
1166 ;;
1167 alpha*-*-linux*)
1168 target_makefile_frag="${target_makefile_frag} config/mt-elfalphapic"
1169 ;;
1170 *)
1171 if test -f ${srcdir}/config/mt-${target_cpu}pic; then
1172 target_makefile_frag="${target_makefile_frag} config/mt-${target_cpu}pic"
1173 fi
1174 ;;
1175 esac
1176 fi
1177
1178 rm -f mt-frag
1179 if [ -n "${target_makefile_frag}" ] ; then
1180 for f in ${target_makefile_frag}
1181 do
1182 cat ${srcdir}/$f >> mt-frag
1183 done
1184 target_makefile_frag=mt-frag
1185 fi
1186
1187 # post-target:
1188
1189 # Make sure that the compiler is able to generate an executable. If it
1190 # can't, we are probably in trouble. We don't care whether we can run the
1191 # executable--we might be using a cross compiler--we only care whether it
1192 # can be created. At this point the main configure script has set CC.
1193 echo "int main () { return 0; }" > conftest.c
1194 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
1195 if [ $? = 0 ] && [ -s conftest -o -s conftest.exe ]; then
1196 :
1197 else
1198 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
1199 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
1200 rm -f conftest*
1201 exit 1
1202 fi
1203 rm -f conftest*
1204
1205 # The Solaris /usr/ucb/cc compiler does not appear to work.
1206 case "${host}" in
1207 sparc-sun-solaris2*)
1208 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
1209 if [ "`type $CCBASE | sed 's/^[^/]*//'`" = "/usr/ucb/cc" ] ; then
1210 could_use=
1211 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
1212 if [ -d /opt/cygnus/bin ] ; then
1213 if [ "$could_use" = "" ] ; then
1214 could_use="/opt/cygnus/bin"
1215 else
1216 could_use="$could_use or /opt/cygnus/bin"
1217 fi
1218 fi
1219 if [ "$could_use" = "" ] ; then
1220 echo "Warning: compilation may fail because you're using"
1221 echo "/usr/ucb/cc. You should change your PATH or CC "
1222 echo "variable and rerun configure."
1223 else
1224 echo "Warning: compilation may fail because you're using"
1225 echo "/usr/ucb/cc, when you should use the C compiler from"
1226 echo "$could_use. You should change your"
1227 echo "PATH or CC variable and rerun configure."
1228 fi
1229 fi
1230 ;;
1231 esac
1232
1233 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
1234 # binutils tools will find libbfd.so.
1235 if [ "${shared}" = "yes" ]; then
1236 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
1237 Makefile > Makefile.tem
1238 rm -f Makefile
1239 mv -f Makefile.tem Makefile
1240
1241 case "${host}" in
1242 *-*-hpux*)
1243 sed -e 's/^RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
1244 Makefile > Makefile.tem
1245 rm -f Makefile
1246 mv -f Makefile.tem Makefile
1247 ;;
1248 esac
1249 fi
1250
1251 # Record target_configdirs and the configure arguments for target and
1252 # build configuration in Makefile.
1253 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
1254 targargs=`echo "${arguments}" | \
1255 sed -e 's/--no[^ ]*//' \
1256 -e 's/--cache[a-z-]*=[^ ]*//' \
1257 -e 's/--ho[a-z-]*=[^ ]*//' \
1258 -e 's/--bu[a-z-]*=[^ ]*//' \
1259 -e 's/--ta[a-z-]*=[^ ]*//'`
1260
1261 # For the build-side libraries, we just need to pretend we're native,
1262 # and not use the same cache file. Multilibs are neither needed nor
1263 # desired.
1264 buildargs="--cache-file=../config.cache --build=${build_alias} --host=${build_alias} ${targargs}"
1265
1266 # Passing a --with-cross-host argument lets the target libraries know
1267 # whether they are being built with a cross-compiler or being built
1268 # native. However, it would be better to use other mechanisms to make the
1269 # sorts of decisions they want to make on this basis. Please consider
1270 # this option to be deprecated. FIXME.
1271 if [ x${is_cross_compiler} = xyes ]; then
1272 targargs="--with-cross-host=${host_alias} ${targargs}"
1273 fi
1274
1275 # Default to --enable-multilib.
1276 if [ x${enable_multilib} = x ]; then
1277 targargs="--enable-multilib ${targargs}"
1278 fi
1279
1280 # Pass --with-newlib if appropriate. Note that target_configdirs has
1281 # changed from the earlier setting of with_newlib.
1282 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
1283 targargs="--with-newlib ${targargs}"
1284 fi
1285
1286 # Pass the appropriate --host, --build, and --cache-file arguments.
1287 targargs="--cache-file=../config.cache --host=${target_alias} --build=${build_alias} ${targargs}"
1288
1289 # provide a proper gxx_include_dir.
1290 # Note, if you change the default, make sure to fix both here and in
1291 # the gcc, libio, and libstdc++ subdirectories.
1292 # Check whether --with-gxx-include-dir or --without-gxx-include-dir was given.
1293 gxx_include_dir=
1294 if test -n "${with_gxx_include_dir}"; then
1295 case "${with_gxx_include_dir}" in
1296 yes )
1297 echo "configure.in: error: bad value ${withval} given for g++ include directory" 1>&2
1298 exit 1
1299 ;;
1300 no )
1301 ;;
1302 * )
1303 gxx_include_dir=${with_gxx_include_dir}
1304 ;;
1305 esac
1306 fi
1307 if test x${gxx_include_dir} = x; then
1308 if test x${enable_version_specific_runtime_libs} = xyes; then
1309 gxx_include_dir='${libsubdir}/include/g++'
1310 else
1311 . ${topsrcdir}/config.if
1312 gxx_include_dir='${prefix}/include/g++'-${libstdcxx_interface}
1313 fi
1314 else
1315 gxx_include_dir=${gxx_include_dir}
1316 fi
1317
1318 FLAGS_FOR_TARGET=
1319 case " $skipdirs " in
1320 *" target-newlib "*) ;;
1321 *)
1322 case "$target" in
1323 *-cygwin*)
1324 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -L$$r/$(TARGET_SUBDIR)/winsup -L$$r/$(TARGET_SUBDIR)/winsup/cygwin -L$$r/$(TARGET_SUBDIR)/winsup/w32api/lib -isystem $$s/winsup/include -isystem $$s/winsup/cygwin/include -isystem $$s/winsup/w32api/include -isystem $$s/newlib/libc/sys/cygwin -isystem $$s/newlib/libc/sys/cygwin32' ;;
1325 esac
1326
1327 # If we're not building GCC, don't discard standard headers.
1328 if test -d ${topsrcdir}/gcc; then
1329 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -nostdinc'
1330
1331 if test "${build}" != "${host}"; then
1332 # On Canadian crosses, CC_FOR_TARGET will have already been set
1333 # by `configure', so we won't have an opportunity to add -Bgcc/
1334 # to it. This is right: we don't want to search that directory
1335 # for binaries, but we want the header files in there, so add
1336 # them explicitly.
1337 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -isystem $$r/gcc/include'
1338
1339 # Someone might think of using the pre-installed headers on
1340 # Canadian crosses, in case the installed compiler is not fully
1341 # compatible with the compiler being built. In this case, it
1342 # would be better to flag an error than risking having
1343 # incompatible object files being constructed. We can't
1344 # guarantee that an error will be flagged, but let's hope the
1345 # compiler will do it, when presented with incompatible header
1346 # files.
1347 fi
1348 fi
1349
1350 case "${target}-${is_cross_compiler}" in
1351 i[3456]86-pc-linux*-no)
1352 # Here host == target, so we don't need to build gcc,
1353 # so we don't want to discard standard headers.
1354 FLAGS_FOR_TARGET=`echo " $FLAGS_FOR_TARGET " | sed -e 's/ -nostdinc / /'`
1355 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -B$$r/$(TARGET_SUBDIR)/newlib/'
1356 ;;
1357 *)
1358 # If we're building newlib, use its generic headers last, but search
1359 # for any libc-related directories first (so make it the last -B
1360 # switch).
1361 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -B$$r/$(TARGET_SUBDIR)/newlib/ -isystem $$r/$(TARGET_SUBDIR)/newlib/targ-include -isystem $$s/newlib/libc/include'
1362 ;;
1363 esac
1364 ;;
1365 esac
1366
1367 # On Canadian crosses, we'll be searching the right directories for
1368 # the previously-installed cross compiler, so don't bother to add
1369 # flags for directories within the install tree of the compiler
1370 # being built; programs in there won't even run.
1371 if test "${build}" = "${host}" && test -d ${topsrcdir}/gcc; then
1372 # Search for pre-installed headers if nothing else fits.
1373 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -B$(build_tooldir)/bin/ -B$(build_tooldir)/lib/ -isystem $(build_tooldir)/include'
1374 fi
1375
1376 if test "x${use_gnu_ld}" = x && test "x${with_gnu_ld}" != xno &&
1377 echo " ${configdirs} " | grep " ld " > /dev/null &&
1378 test -d ${srcdir}/ld; then
1379 # Arrange for us to find uninstalled linker scripts.
1380 FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -L$$r/ld'
1381 fi
1382
1383 if test "x${CC_FOR_TARGET+set}" = xset; then
1384 :
1385 elif test -d ${topsrcdir}/gcc; then
1386 CC_FOR_TARGET='$$r/gcc/xgcc -B$$r/gcc/'
1387 elif test "$host" = "$target"; then
1388 CC_FOR_TARGET='$(CC)'
1389 else
1390 CC_FOR_TARGET=`echo gcc | sed -e 's/x/x/' ${program_transform_name}`
1391 fi
1392 # On Canadian crosses, configure reads CC_FOR_TARGET from Makefile,
1393 # if Makefile exists. Prevent $(FLAGS_FOR_TARGET) from being duplicated.
1394 case $CC_FOR_TARGET in
1395 *' $(FLAGS_FOR_TARGET)') ;;
1396 *) CC_FOR_TARGET=$CC_FOR_TARGET' $(FLAGS_FOR_TARGET)' ;;
1397 esac
1398
1399 if test "x${CHILL_FOR_TARGET+set}" = xset; then
1400 :
1401 elif test -d ${topsrcdir}/gcc; then
1402 CHILL_FOR_TARGET='$$r/gcc/xgcc -B$$r/gcc/ -L$$r/gcc/ch/runtime/'
1403 elif test "$host" = "$target"; then
1404 CHILL_FOR_TARGET='$(CC)'
1405 else
1406 CHILL_FOR_TARGET=`echo gcc | sed -e 's/x/x/' ${program_transform_name}`
1407 fi
1408 case $CHILL_FOR_TARGET in
1409 *' $(FLAGS_FOR_TARGET)') ;;
1410 *) CHILL_FOR_TARGET=$CHILL_FOR_TARGET' $(FLAGS_FOR_TARGET)' ;;
1411 esac
1412
1413 if test "x${CXX_FOR_TARGET+set}" = xset; then
1414 :
1415 elif test -d ${topsrcdir}/gcc; then
1416 CXX_FOR_TARGET='$$r/gcc/`case $$dir in libstdc++-v3) echo xgcc ;; *) echo g++ ;; esac` -B$$r/gcc/ -nostdinc++ '$libstdcxx_flags
1417 elif test "$host" = "$target"; then
1418 CXX_FOR_TARGET='$(CXX)'
1419 else
1420 CXX_FOR_TARGET=`echo c++ | sed -e 's/x/x/' ${program_transform_name}`
1421 fi
1422 case $CXX_FOR_TARGET in
1423 *' $(FLAGS_FOR_TARGET)') ;;
1424 *) CXX_FOR_TARGET=$CXX_FOR_TARGET' $(FLAGS_FOR_TARGET)' ;;
1425 esac
1426 qCXX_FOR_TARGET=`echo "$CXX_FOR_TARGET" | sed 's,[&%],\\\&,g'`
1427
1428 # We want to defer the evaluation of `cmd`s and shell variables in
1429 # CXX_FOR_TARGET when recursing in the top-level Makefile, such as for
1430 # bootstrap. We'll enclose CXX_FOR_TARGET_FOR_RECURSIVE_MAKE in single
1431 # quotes, but we still have to duplicate `$'s so that shell variables
1432 # can be expanded by the nested make as shell variables, not as make
1433 # macros.
1434 qqCXX_FOR_TARGET=`echo "$qCXX_FOR_TARGET" | sed -e 's,[$][$],$$$$,g'`
1435
1436 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
1437 -e "s%^TARGET_CONFIGARGS[ ]*=.*$%TARGET_CONFIGARGS = ${targargs}%" \
1438 -e "s%^FLAGS_FOR_TARGET[ ]*=.*$%FLAGS_FOR_TARGET = ${FLAGS_FOR_TARGET}%" \
1439 -e "s%^CC_FOR_TARGET[ ]*=.*$%CC_FOR_TARGET = ${CC_FOR_TARGET}%" \
1440 -e "s%^CHILL_FOR_TARGET[ ]*=.*$%CHILL_FOR_TARGET = ${CHILL_FOR_TARGET}%" \
1441 -e "s%^CXX_FOR_TARGET[ ]*=.*$%CXX_FOR_TARGET = ${qCXX_FOR_TARGET}%" \
1442 -e "s%^CXX_FOR_TARGET_FOR_RECURSIVE_MAKE[ ]*=.*$%CXX_FOR_TARGET_FOR_RECURSIVE_MAKE = ${qqCXX_FOR_TARGET}%" \
1443 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
1444 -e "s%^BUILD_SUBDIR[ ]*=.*$%BUILD_SUBDIR = ${build_subdir}%" \
1445 -e "s%^BUILD_CONFIGARGS[ ]*=.*$%BUILD_CONFIGARGS = ${buildargs}%" \
1446 -e "s%^gxx_include_dir[ ]*=.*$%gxx_include_dir=${gxx_include_dir}%" \
1447 Makefile > Makefile.tem
1448 rm -f Makefile
1449 mv -f Makefile.tem Makefile
1450
1451 #
1452 # Local Variables:
1453 # fill-column: 131
1454 # End:
1455 #
This page took 0.101071 seconds and 4 git commands to generate.